unit uMain;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus,MMSystem,ShellAPI, ImgList, ComCtrls,
  ToolWin;
type

  TMainForm = class(TForm)
    TimerMain: TTimer;    MainMenu1: TMainMenu;
    N1: TMenuItem;    N2: TMenuItem;
    N3: TMenuItem;    N4: TMenuItem;
    OpenDialogLvt: TOpenDialog;
    ResetCPU1: TMenuItem;
    N11: TMenuItem;

    procedure TimerMainTimer(Sender: TObject);
    procedure do_write(addr : word; bt : byte);
    procedure i8080_init;
    procedure i8080_reset(addr: word);
    function  do_read(addr : integer): word;
    procedure do_write2(a_lo : word; a_hi : word; bt : byte);
    function  do_read2(a_lo : word; a_hi : word): word;
    function  compute_color_index(port : byte; color : tcolor): tcolor;
    procedure WriteVRAM(b:Byte;x,y: integer);
    procedure init_memory();
    function  do_input(port : byte): byte;
    procedure do_output(port : byte; bt : byte);
    procedure kbd(mask : word; press : boolean);
    procedure reset1;
    procedure load_bios;
    function  get_var(var1: word): word;
    procedure set_var(var1, val: word);
    procedure warm_start();
    procedure do_pause();
    procedure i8080_do_opcodes(nb_cycles : integer);
    procedure draw_screen();
    procedure FirstPusk;
    function  readmask (keynum: word): word;
    procedure N4Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure NewLoadFile(filenameDnD: string;start : boolean);
    procedure ResetComp;
    procedure ResetCPU1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure VRAMTest(c1,b:Byte);
    procedure CalculateColor;
    procedure Russian1Click(Sender: TObject);
    procedure English1Click(Sender: TObject);
    procedure Wmemory;
    procedure Rmemory;
    procedure Wflags;
    procedure Rflags;
  private
    { Private declarations }
  public
    procedure WMDropFiles(var Msg: TMessage); message wm_DropFiles;
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  var { }   rgA,rgB,rgC,rgD,rgE,rgH,rgL,rgF,rgPC,rgSP :Cardinal;
  var { }   fS, fZ, f5, fA, f3,fP,f1,fC : Cardinal;
  memoryM: array [0..65535] of byte;  //    $FFFF
  flagsM: array [0..256] of  word;


    opcode : byte; //    !!!

    halt_inv :byte;
    halt_opc :byte;
    halt_hlt :byte;
    halt_bpx :byte;
    halt_bpr :byte;
    halt_bpw :byte;
    halt_bpi :byte;
    halt_bpo :byte;

    FPusk: boolean; //  

    gamecanvas: tbitmap; //       


    video : array [0..16384] of byte;  //  
    VideoDirty : array [0..16384] of word; //   
    ports : array [0..256]   of byte;      // 
    bios  : array [0..65535] of byte;    //    ,      
    Myfile: array [0..90000] of byte; //    DUMP SAV 

    SuperColor: array[0..255, 0..255,1..4] of Tcolor; //     

    pause : boolean; //  
    FPS : integer;  // frames per second :-)

    speaker: array [0..2000] of word; //  
    speaked : word;
    soundData: array [0..2000] of BYTE;
    soundEnabled : boolean;
   { header : TWaveFormatEx;
    waveOut : hWaveOut;
    outHdr : TWaveHdr;
    pBuf : tHandle;
    pBuffer : pointer;}


    myfilelength: word; //   
    //_filePos : integer;

    r_Halted: boolean;

    kbd_base : array  [0..8] of byte;  //   
    kbd_ext : array  [0..4] of byte;

    BasicStack : word;    //    
    BasicHotEntry : word;
    BasicProgBegin : word;
    BasicProgEnd : word;

    opcodes_to_run : integer;

    curSnd : word;
    restClock : word;

const MyColor:array[0..3] of Tcolor=(clBlack,clLime,clBlue,clRed);

implementation
var Wmemory_a,Wmemory_b:Cardinal; procedure TMainForm.Wmemory; begin memoryM[Wmemory_a]:=Wmemory_b; end;
var Rmemory_a,Rmemory_result:Cardinal; procedure TMainForm.Rmemory; begin Rmemory_result:=memoryM[Rmemory_a];end;
var Wflags_a,Wflags_b:Cardinal; procedure TMainForm.Wflags; begin flagsM[Wflags_a]:=Wflags_b; end;
var Rflags_a,Rflags_result:Cardinal; procedure TMainForm.Rflags; begin Rflags_result:=flagsM[Rflags_a];end;

{$R *.dfm}

procedure TMainForm.WMDropFiles(var Msg: TMessage);   //      
var
FileName: array[0..256] of char;
begin
DragQueryFile(THandle(Msg.WParam), 0, FileName, SizeOf(Filename));
MainForm.Caption:=FileName;
NewLoadFile(FileName,true);
DragFinish(THandle(Msg.WParam));
end;

procedure TMainForm.do_write(addr : word; bt : byte); //     :-)
begin
  addr:=(addr and $FFFF);
  if (addr>=$C000) then
  begin
    exit;
  end;
  if ((ports[$C2] and 2)<>0) then
  begin
    Wmemory_A:=addr; Wmemory_B:=bt; Wmemory;
  end
  else
     if (addr<$4000) then
       begin
         exit;
       end
       else
         if (addr<$8000) then
           begin
              video[addr-$4000]:=bt;
             // memory[addr]:=bt; //        
           end
           else
           begin
               Wmemory_A:=addr; Wmemory_B:=bt; Wmemory;
           end;
end;



procedure TMainForm.i8080_init;
var
  j,i : word;
begin
  i:=0;
  while (i<256) do
  begin
    //flags[i]:=f1 or fP;
    Wflags_a:=i;Wflags_b:=(f1 or fP);Wflags;
    j:=0;
    while (j<8) do
    begin
       if ((i and (1 SHL j))<>0) then
             begin
//                flags[i]:=(flags[i] xor fP);
    Rflags_a:=i;Rflags;
    Wflags_a:=i;Wflags_b:=(Rflags_Result xor fP);Wflags;
             end;
      inc(j);
    end;
       if ((i and $80)<>0) then
             begin
//               flags[i]:=(flags[i] or fS);
                   Rflags_a:=i;Rflags;
          Wflags_a:=i;Wflags_b:=(Rflags_Result or fS);Wflags;
             end;
       if (i=0) then
             begin
//               flags[i]:=(flags[i] or fZ);
                   Rflags_a:=i;Rflags;
          Wflags_a:=i;Wflags_b:=(Rflags_Result or fZ);Wflags;
             end;
    inc(i);
  end;
end;

procedure TMainForm.i8080_reset(addr: word);
begin
//  r_A:=0;  r_F:=0;  r_B:=0;  r_C:=0;  r_D:=0;  r_E:=0;  r_H:=0;  r_L:=0;
//  r_SP:=0;  r_Halted:=false;  clock:=0;  r_PC:=addr;
end;



function TMainForm.do_read(addr : integer): word; //    
begin
  addr:=(addr and $FFFF);
   if ((ports[$C2] and 2)<>0) then
  begin

     Rmemory_A:=addr; Rmemory; result := Rmemory_result;
  end
  else
  if (addr>$7FFF) then
  begin
     Rmemory_A:=addr; Rmemory; result := Rmemory_result;
  end
  else if (addr<$4000) then
  begin
    result := 0;
  end
  else begin
    result := video[addr-$4000];
  end;
end;

procedure TMainForm.do_write2(a_lo : word; a_hi : word; bt : byte);  // 
begin
  do_write(a_lo+(a_hi SHL 8),bt);
end;

function TMainForm.do_read2(a_lo : word; a_hi : word): word;
begin
  result := do_read(a_lo+(a_hi SHL 8));
end;

procedure TMainForm.init_memory();    //    
var
  j , i : integer;
begin
  i:=$0000;
  while (i<$10000) do
  begin
         Wmemory_A:=i; Wmemory_B:=0; Wmemory;
    inc(i);
  end;
  i:=$0000;
  while (i<$4000) do begin
    video[i]:=0;
    inc(i);
  end;
  i:=$0000;
  while (i<$100) do begin
    ports[i]:=0;
    inc(i);
  end;
  i:=0;
  while (i<8) do begin
    kbd_base[i]:=0;
    inc(i);
  end;
  i:=0;
  while (i<4) do begin
    kbd_ext[i]:=0;
    inc(i);
  end;
  i:=0;
  while (i<256) do begin
//    flags[i]:=(f1 or fP);
          Wflags_a:=i;Wflags_b:=(f1 or fP);Wflags;
    j:=0;
    while (j<8) do begin
      if ((i and (1 shl j))<>0) then
      begin
//        flags[i]:= (flags[i] xor fP);
        Rflags_a:=i;Rflags;
        Wflags_a:=i;Wflags_b:=(Rflags_result xor fP);Wflags;
      end;
      inc(j);
    end;
    if ((i and $80)<>0) then
    begin
//      flags[i]:= (flags[i] or fS);
        Rflags_a:=i;Rflags;
        Wflags_a:=i;Wflags_b:=(Rflags_result or fS);Wflags;
    end;

    if (i=0) then
    begin
//      flags[i]:=(flags[i] or fZ);
        Rflags_a:=i;Rflags;
        Wflags_a:=i;Wflags_b:=(Rflags_result xor fZ);Wflags;
    end;
    inc(i);
  end;
end;


function TMainForm.do_input(port : byte): byte;  //     in
var
  i,r : integer;
  nD2 ,nD0 : byte;
begin
  nD2:=0;
  nD0:=0;
  port:=$C0+(port and $13);
  case port of
  $C2:     begin result := ports[$C2]; end;
  $D1:     begin
             nD0:=not ports[$D0];
             r:=0;
             i:=0;
             while (i<8) do
             begin
              if ((nD0 and (1 SHL i))<>0) then
                 begin
                    r:=(r or kbd_base[i]);
                 end;
              inc(i);
             end;
             result :=  ((not r) and $FF);
           end;
   $D2:    begin
             nD2:= not ports[$D2];
             r:=0;
             i:=0;
             while (i<4) do
              begin
               if ((nD2 and (1 SHL i))<>0) then
                  begin
                   r:=(r or kbd_ext[i]);
                  end;
               inc(i);
              end;
              result := not ((r SHL 4) or (nD2 and $0F)) and $FF;
            end
     else
        begin
           result := $FF;
        end;
end;
end;

procedure TMainForm.do_output(port : byte; bt : byte); // out
begin
  port:=$C0+(port and $13);
  case port of
  $c1:  begin //   
          fillchar(VideoDirty,sizeof(VideoDirty),257); //  
        end;

  end;
  ports[port]:=bt;
end ;



procedure TMainForm.kbd(mask : word; press : boolean); //      
var
  brow : byte;
  erow : byte;
  bcol : byte;
  ecol : byte;
begin
  bcol:=(mask SHR 12) and $0F;
  brow:=(mask SHR 8) and $0F;
  ecol:=(mask SHR 4) and $0F;
  erow:=(mask SHR 0) and $0F;
  
  if ((brow<8) and (bcol<8)) then
  begin
   if (press) then
    begin
      kbd_base[bcol]:=(kbd_base[bcol] or (1 SHL brow));
    end else begin
      kbd_base[bcol]:= (kbd_base[bcol] and (not(1 SHL brow)));
    end;
  end;

  if ((erow<8) and (ecol<4)) then
  begin
    if (press) then
    begin
      kbd_ext[ecol]:= (kbd_ext[ecol]or (1 SHL erow));
    end else begin
      kbd_ext[ecol]:= (kbd_ext[ecol] and (not(1 SHL erow)));
    end;
  end;
end;

procedure TMainForm.reset1;    //   :)
var
  i : word;
begin
  i:=0;
  while (i<256) do begin
    ports[i]:=$FF;
    inc(i);
  end;
  i8080_init;
end;

procedure TMainForm.load_bios;    //    
var
i: word;
b: byte;
f: file of byte;
begin
  i:=0;
  AssignFile(F,ExtractFilePath(Application.ExeName)+'\bios.dat');
  Reset(F);                   //     :)
  while not eof(f) do
   begin
    read(F,b);
    bios[i]:=b; //    ,   
    inc(i);
   end;
  closeFile(F);
  i:=0;
  while (i<$4000) do begin
    //memory[$C000+i]:=bios[22+i];
         Wmemory_A:=$C000+i; Wmemory_B:=bios[22+i]; Wmemory;
    inc(i);
  end;
end;


procedure TMainForm.N2Click(Sender: TObject);
begin
  OpenDialogLvt.InitialDir:=ExtractFilePath(Application.ExeName);
  if OpenDialogLvt.Execute then NewLoadFile(OpenDialogLvt.FileName,true);
end;

procedure TMainForm.N4Click(Sender: TObject);
begin
gamecanvas.Free;
close;
end;

function TMainForm.get_var(var1: word): word;  //       
begin
//    result:= memory[var1] + memory[var1+1]*256;
end;

procedure TMainForm.set_var(var1, val: word);
begin
//    memory[var1]:= (val and $FF);
//    memory[var1+1]:= (round(val/256) and $FF);
end;

procedure TMainForm.warm_start();  //  
begin
  ports[$C2]:=$FF;
  rgSP:=BasicStack;
  set_var(BasicStack,BasicHotEntry);
  rgPC:=BasicHotEntry;
end;

procedure TMainForm.NewLoadFile(filenameDnD: string; start : boolean);  //    
var
f:file of byte;
b:Byte;
s: string;
posBas, Xend ,Xbeg ,Xrun : word;
i: integer;
begin
  s:='';
      AssignFile(f,filenameDnD); //    
      Reset(f);
      for I:= 0 to 8  do
        begin
           read(f,b);
           s:=s+chr(b);
           //Myfile[j]:=strtoint(s);
           // Size(f);
           //seek(f,100);
        end;
      if s='LVOV/2.0/' then //  LVT 
      begin
         read(f,b);
         if b=$D0 then      //  
         begin
           seek(F,0); //    
           i:=0;
           while not eof(f) do
              begin
                read(F,b);
                Myfile[i]:=b;
                inc(i);
              end;
           myfilelength:=i;
           closeFile(F);     // 
           Xbeg:=Myfile[16]+Myfile[17]*256;
           Xend:=Myfile[18]+Myfile[19]*256;
           Xrun:=Myfile[20]+Myfile[21]*256;
           if (start) then
              begin
                warm_start();
                rgPC:=Xrun;
              end;
           i:=0;
           while (i<=Xend-Xbeg) do
              begin
               do_write(Xbeg+i,Myfile[i+22]);
               inc(i);
              end;
         end
         else
         begin      // e (    :-) )
           seek(F,0); //    
           i:=0;
           while not eof(f) do
              begin
                read(F,b);
                Myfile[i]:=b;
                inc(i);
              end;
            myfilelength:=i-1;
            warm_start();
            posBas:=get_var(BasicProgBegin);
            i:=0;
            while (i<myfilelength-16) do
               begin
                do_write(posBas+i,Myfile[i+16]);
                inc(i);
               end;
              set_var(BasicProgEnd,posBas+myfilelength-16);
              //  RUN
              MainForm.SetFocus;

              //i8080_do_opcodes(opcodes_to_run);


              //KeyboardForm.SendKeys('RUN');
         end;
       end;
      if s='LVOV/DUMP' then //  SAV    
         begin
           seek(F,0); //    
           i:=0;
           while not eof(f) do
              begin
                read(F,b);
                Myfile[i]:=b;
                inc(i);
              end;
           i:=0;
           closeFile(F);
           while (i<$10000) do
           begin
            // memory[i]:=Myfile[17+i];
                Wmemory_A:=i; Wmemory_B:=Myfile[17+i]; Wmemory;
             inc(i);
           end;
           i:=0;
           while (i<$4000) do
           begin
            video[i]:=Myfile[17+$10000+i];
            inc(i);
           end;
           i:=0;
           while (i<$100) do
           begin
            ports[i]:=Myfile[17+$10000+$4000+i];
            inc(i);
           end;
           rgB:=Myfile[17+$10000+$4000+$100];
           rgH:=Myfile[17+$10000+$4000+$100+4];
           rgC:=Myfile[17+$10000+$4000+$100+1];
           rgL:=Myfile[17+$10000+$4000+$100+5];
           rgD:=Myfile[17+$10000+$4000+$100+2];
           rgA:=Myfile[17+$10000+$4000+$100+6];
           rgE:=Myfile[17+$10000+$4000+$100+3];
           rgF:=Myfile[17+$10000+$4000+$100+7];
           rgSP:=Myfile[17+$10000+$4000+$100+9]*256+Myfile[17+$10000+$4000+$100+8];
           rgPC:=Myfile[17+$10000+$4000+$100+11]*256+Myfile[17+$10000+$4000+$100+10];
           fillchar(VideoDirty,sizeof(VideoDirty),257); //  
           draw_screen;
         end;
end;

procedure  TMainForm.do_pause();
begin
	pause := not pause;
end;

procedure TMainForm.i8080_do_opcodes(nb_cycles : integer);    //  
var tmp3,  tmp2,  tmp1,  opcode : integer;
var { }   r_A,r_B,r_C,r_D,r_E,r_H,r_L,r_F,r_PC,r_SP : integer;
clock:Cardinal;
{ }   f_S, f_Z, f_5, f_A, f_3,f_P,f_1,f_C : Integer;
procedure rF1;
Begin
//r_F:=(flags[tmp2] or (r_F and f_C));
        Rflags_a:=tmp2;Rflags;
    r_F:=(Rflags_result or (r_F and f_C));
end;

procedure rF2;
Begin
//r_F:=flags[tmp2 and $FF];
        Rflags_a:=(tmp2 and $FF);Rflags;
    r_F:=Rflags_result;
end;
procedure rF3; begin
  //rF3;//r_F:=flags[tmp2];
        Rflags_a:=(tmp2);Rflags;
    r_F:=Rflags_result;
               end;
procedure rF4; begin
//rF4;//    r_F:=flags[0];
    Rflags_a:=(0);Rflags;
    r_F:=Rflags_result;
 end;
procedure rF5; begin
//rF5; r_F:=flags[r_A] or (r_F and f_A);
 Rflags_a:=(r_A);Rflags;
    r_F:=(Rflags_result or (r_F and f_A));
end;
procedure clp4;begin clock:=clock+4; end;



begin
r_A:=integer(rgA);r_b:=integer(rgB);r_c:=integer(rgC);r_d:=integer(rgD);
r_e:=integer(rgE);r_H:=integer(rgH);r_L:=integer(rgL);r_F:=integer(rgF);
r_PC:=integer(rgPC);r_SP:=integer(rgSP);

f_S:=integer(fS);f_Z:=integer(fZ);f_5:=integer(f5);f_A:=integer(fA);
f_3:=integer(f3);f_P:=integer(fP);f_1:=integer(f1);f_C:=integer(fC);

  clock:=0; tmp1:=0;  tmp2:=0;  tmp3:=0;  // :-)
 while (clock < nb_cycles) do
 begin
  opcode:=do_read(r_PC);

case opcode of         //    00 .. FF,   clock    ""  ...
                       //   ,         !!!!
  $00:
  begin
    clp4;
    r_PC:=r_PC+1;
  end;
  $F3:
  begin
    clp4;
    r_PC:=r_PC+1;
  end;
  $FB:
  begin
    clp4;
    r_PC:=r_PC+1;
  end;

  $01:
  begin
    r_B:=do_read(r_PC+2);
    r_C:=do_read(r_PC+1);
    clock:=clock+10;
    r_PC:=r_PC+3;
  end;
  
  $02: 
  begin
    do_write2(r_C,r_B,r_A);
    clock:=clock+7;
    r_PC:=r_PC+1;
  end;

  $03:
  begin
    r_C:=r_C+1;
    if (r_C>$FF) then
    begin
      r_C:=0;
      r_B:=r_B+1;
      if (r_B>$FF) then
      begin
        r_B:=0;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;

  $04:
  begin
    tmp2:=((r_B+1) and $FF);
    RF1;
    if (((tmp2 xor r_B) and $10)<>0) then
    begin
      r_F:=r_F or f_A;
    end;
    r_B:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $05: 
  begin
    tmp2:=((r_B-1) and $FF);
    RF1;

    if (((tmp2 xor r_B) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_B:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $06: 
  begin
    r_B:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $07: 
  begin
    r_A:=r_A SHL 1;
    if (r_A>$FF) then
    begin
      r_A:=r_A or 1;
      r_F:=r_F or f_C;
      r_A:= r_A and $FF;
    end
    else
    begin
      r_F:=(r_F and  (not f_C));
    end;
    clp4;
    r_PC:=r_PC+1;
  end;
  $08:  begin
           begin
           clp4;
           r_PC:=r_PC+1;
           end; end;
  $10:  begin
           begin
           clp4;
           r_PC:=r_PC+1;
           end; end;
  $18:  begin
           begin
           clp4;
           r_PC:=r_PC+1;
           end; end;
  $20:  begin
           begin
           clp4;
           r_PC:=r_PC+1;
           end; end;
  $28:  begin
           begin
           clp4;
           r_PC:=r_PC+1;
           end; end;
  $30:  begin
           begin
           clp4;
           r_PC:=r_PC+1;
           end; end;
  $38:
  begin

           begin
           clp4;
           r_PC:=r_PC+1;
           end;
  end;
  
  $09: 
  begin
    r_L:=r_L+r_C;
    r_H:=r_H+r_B;
    if (r_L>$FF) then
    begin
      inc(r_H);
      r_L:=(r_L and $FF);
    end;
    if (r_H>$FF) then
    begin
      r_H:=(r_H and $FF);
      r_F:=(r_F or f_C);
    end
    else
    begin
      r_F:=(r_F and (not f_C));
    end;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $0A: 
  begin
    r_A:=do_read2(r_C,r_B);
    clock:=clock+7;
    r_PC:=r_PC+1;
  end;

  $0B: 
  begin
    r_C:=r_C-1;
    if (r_C<0) then
    begin
      r_C:=$FF;
      r_B:=r_B-1;
      if (r_B<0) then
      begin
        r_B:=$FF;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $0C: 
  begin
    tmp2:=((r_C+1) and $FF);
    RF1;
    if (((tmp2 xor r_C) and $10)<>0) then
    begin
      r_F:=r_F or f_A;
    end;
    r_C:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;

  $0D:
  begin
    tmp2:=((r_C-1) and $FF);
    RF1;

    if (((tmp2 xor r_C) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_C:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $0E: 
  begin
    r_C:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $0F: 
  begin
    tmp1:=(r_A and 1);
    r_A:=(r_A shr 1);
    if (tmp1<>0) then
    begin
      r_A:=(r_A or $80);
      r_F:=(r_F or f_C);
    end
    else
    begin
      r_F:=(r_F and ( not f_C));
    end;
    clp4;
    r_PC:=r_PC+1;
  end;
  
  $11: 
  begin
    r_D:=do_read(r_PC+2);
    r_E:=do_read(r_PC+1);
    clock:=clock+10;
    r_PC:=r_PC+3;
  end;
  
  $12: 
  begin
    do_write2(r_E,r_D,r_A);
    clock:=clock+7;
    r_PC:=r_PC+1;
  end;
  
  $13: 
  begin
    r_E:=r_E+1;
    if (r_E>$FF) then
    begin
      r_E:=0;
      r_D:=r_D+1;
      if (r_D>$FF) then
      begin
        r_D:=0;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $14: 
  begin
    tmp2:=((r_D+1)and $FF);
    RF1;
    
    if (((tmp2 xor r_D) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_D:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $15: 
  begin
    tmp2:=((r_D-1)and $FF);
    RF1;
    
    if (((tmp2 xor r_D) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_D:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $16: 
  begin
    r_D:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $17: 
  begin
    r_A:=(r_A shl 1);

    if ((r_F and f_C)<>0) then 
    begin
      r_A:=(r_A or 1);
    end;
    
    if (r_A>$FF) then 
    begin
      r_F:=(r_F or f_C);
      r_A:=(r_A and $FF);
    end else begin
      r_F:=(r_F and (not f_C));
    end;
    clp4;
    r_PC:=r_PC+1;
  end;
  
  $19: 
  begin
    r_L:=(r_L + r_E);
    r_H:=(r_H + r_D);
    
    if (r_L>$FF) then 
    begin
      inc(r_H);
      r_L:=(r_L and $FF);
    end;

    if (r_H>$FF) then 
    begin
      r_H:=(r_H and $FF);
      r_F:=(r_F or f_C);
    end
    else
    begin
      r_F:=(r_F and not (f_C));
    end;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $1A: 
  begin
    r_A:=do_read2(r_E,r_D);
    clock:=clock+7;
    r_PC:=r_PC+1;
  end;
  
  $1B: 
  begin
    r_E:=r_E-1;
    if (r_E<0) then
    begin
      r_E:=$FF;
      r_D:=r_D-1;
      if (r_D<0) then
      begin
        r_D:=$FF;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $1C: 
  begin
    tmp2:=((r_E+1)and $FF);
    RF1;

    if (((tmp2 xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_E:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $1D: 
  begin
    tmp2:=((r_E-1) and $FF);
    RF1;

    if (((tmp2 xor r_E) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_E:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $1E: 
  begin
    r_E:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $1F: 
  begin
    tmp1:=(r_A and 1);
    r_A:=(r_A SHR 1);
    
    if ((r_F and f_C)<>0) then
    begin
      r_A:=(r_A or $80);
    end;

    if (tmp1<>0) then
    begin
      r_F:=(r_F or f_C);
    end
    else
    begin
      r_F:=(r_F and not(f_C));
    end;
    clp4;
    r_PC:=r_PC+1;
  end;

  $21:
  begin
    r_H:=do_read(r_PC+2);
    r_L:=do_read(r_PC+1);
    clock:=clock+10;
    r_PC:=r_PC+3;
  end;

  $22: 
  begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    do_write(tmp1,r_L);
    do_write(tmp1+1,r_H);
    clock:=clock+16;
    r_PC:=r_PC+3;
  end;
  
  $23: 
  begin
    r_L:=r_L+1;
    if (r_L>$FF) then
    begin
      r_L:=0;
      r_H:=r_H+1;
      if (r_H>$FF) then
      begin
        r_H:=0;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $24: 
  begin
    tmp2:=((r_H+1) and $FF);
    RF1;
    if (((tmp2 xor r_H) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_H:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $25: 
  begin
    tmp2:=((r_H-1) and $FF);
    RF1;
    if (((tmp2 xor r_H) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_H:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $26: 
  begin
    r_H:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $27: 
  begin
    tmp1:=0;
    if (((r_F and f_C)<>0) or  (r_A>$99)) then
    begin
      tmp1:=(tmp1 or $60);
    end;
    if (((r_F and f_A)<>0)    or  ((r_A and $0F)>$09)) then
    begin
      tmp1:=(tmp1 or $06);
    end;
    tmp2:=r_A+tmp1;
    RF2;
    if (((tmp2 xor r_A xor tmp1) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    if (tmp2>$FF) then
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
  end;
  
  $29: 
  begin
    r_L:=r_L + r_L;
    r_H:=r_H + r_H;
    
    if (r_L>$FF) then 
    begin
      inc(r_H);
      r_L:=(r_L and $FF);
    end;
    if (r_H>$FF) then
    begin
      r_H:=(r_H and $FF);
      r_F:=(r_F or f_C);
    end else begin
      r_F:=(r_F and (not f_C));
    end;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $2A: 
  begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_L:=do_read(tmp1);
    r_H:=do_read(tmp1+1);
    clock:=clock+16;
    r_PC:=r_PC+3;
  end;
  
  $2B: 
  begin
    r_L:=r_L-1;
    if (r_L <0) then
    begin
      r_L:=$FF;
      r_H:=r_H-1;
      if (r_H<0) then
      begin
        r_H:=$FF;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $2C: 
  begin
    tmp2:=((r_L+1) and $FF);
    RF1;
    if (((tmp2 xor r_L) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_L:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $2D: 
  begin
    tmp2:=((r_L-1) and $FF);
    RF1;
    if (((tmp2 xor r_L) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_L:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $2E: 
  begin
    r_L:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $2F: 
  begin
    r_A:=(r_A xor $FF);
    clp4;
    r_PC:=r_PC+1;
  end;
  
  $31: 
  begin
    r_SP:=(do_read(r_PC+2) shl 8)+do_read(r_PC+1);
    clock:=clock+10;
    r_PC:=r_PC+3;
  end;
  
  $32: 
  begin
    do_write2(do_read(r_PC+1),do_read(r_PC+2),r_A);
    clock:=clock+13;
    r_PC:=r_PC+3;
  end;
  
  $33: 
  begin
    if (r_SP=$FFFF) then
    begin
      r_SP:=0;
    end
    else
    begin
      inc(r_SP);
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $34: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=((tmp1+1)  and $FF);
RF1;

    if (((tmp2 xor tmp1) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    do_write2(r_L,r_H,tmp2);
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $35: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=((tmp1-1) and $FF);
    RF1;


    if (((tmp2 xor tmp1) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    do_write2(r_L,r_H,tmp2);
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;

  $36:
  begin
    do_write2(r_L,r_H,do_read(r_PC+1));
    clock:=clock+10;
    r_PC:=r_PC+2;
  end;

  $37:
  begin
    r_F:=(r_F or f_C);
    clp4;
    r_PC:=r_PC+1;
  end;
  
  $39: 
  begin
    r_L:=(r_L + (r_SP and $FF));
    r_H:=(r_H + ((r_SP shr 8) and $FF));
    if (r_L>$FF) then
    begin
      inc(r_H);
      r_L:=(r_L and $FF);
    end;
    if (r_H>$FF) then 
    begin
      r_H:=(r_H and $FF);
      r_F:=(r_F or f_C);
    end else begin
      r_F:=(r_F and (not f_C));
    end;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $3A: 
  begin
    r_A:=do_read2(do_read(r_PC+1),do_read(r_PC+2));
    clock:=clock+13;
    r_PC:=r_PC+3;
  end;
  
  $3B: 
  begin
    if (r_SP<>0) then 
    begin
      r_SP:=r_SP-1;
    end
    else
    begin
      r_SP:=$FFFF;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $3C: 
  begin
    tmp2:=((r_A+1) and $FF);
    RF1;
    if (((tmp2 xor r_A) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;

  $3D:
  begin
    tmp2:=((r_A-1) and $FF);
    RF1;
    if (((tmp2 xor r_A) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $3E: 
  begin
    r_A:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $3F: 
  begin
    r_F:=r_F xor f_C;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $40:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $49:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $52:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $5B:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $64:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $6D:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $7F:
  begin
    clock:=clock+5;    r_PC:=r_PC+1;
  end;

  $41:
  begin
    r_B:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;

  $42:
  begin
    r_B:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $43: 
  begin
    r_B:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $44: 
  begin
    r_B:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $45: 
  begin
    r_B:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $46: 
  begin
    r_B:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $47: 
  begin
    r_B:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $48: 
  begin
    r_C:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4A: 
  begin
    r_C:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4B: 
  begin
    r_C:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4C: 
  begin
    r_C:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4D: 
  begin
    r_C:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4E: 
  begin
    r_C:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $4F: 
  begin
    r_C:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $50: 
  begin
    r_D:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $51: 
  begin
    r_D:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $53: 
  begin
    r_D:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $54: 
  begin
    r_D:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $55: 
  begin
    r_D:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $56: 
  begin
    r_D:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $57: 
  begin
    r_D:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $58: 
  begin
    r_E:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $59: 
  begin
    r_E:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $5A: 
  begin
    r_E:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $5C: 
  begin
    r_E:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $5D: 
  begin
    r_E:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $5E: 
  begin
    r_E:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $5F: 
  begin
    r_E:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $60: 
  begin
    r_H:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $61: 
  begin
    r_H:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $62: 
  begin
    r_H:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $63: 
  begin
    r_H:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $65: 
  begin
    r_H:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $66: 
  begin
    r_H:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $67: 
  begin
    r_H:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $68: 
  begin
    r_L:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $69: 
  begin
    r_L:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $6A: 
  begin
    r_L:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $6B: 
  begin
    r_L:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $6C: 
  begin
    r_L:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $6E: 
  begin
    r_L:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $6F: 
  begin
    r_L:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $70: 
  begin
    do_write2(r_L,r_H,r_B);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $71: 
  begin
    do_write2(r_L,r_H,r_C);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $72: 
  begin
    do_write2(r_L,r_H,r_D);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $73: 
  begin
    do_write2(r_L,r_H,r_E);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $74: 
  begin
    do_write2(r_L,r_H,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $75: 
  begin
    do_write2(r_L,r_H,r_L);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $76: 
  begin
   // cpu_halt_state:=true;
   // cpu_halt_reason:=halt_hlt;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $77: 
  begin
    do_write2(r_L,r_H,r_A);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $78: 
  begin
    r_A:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $79: 
  begin
    r_A:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7A: 
  begin
    r_A:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7B: 
  begin
    r_A:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7C: 
  begin
    r_A:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7D: 
  begin
    r_A:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7E: 
  begin
    r_A:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $80: 
  begin
    tmp2:=r_A+r_B;
    RF2;
    
    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=(tmp2 and $FF);
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $81: 
  begin
    tmp2:=r_A+r_C;
    RF2;
    
    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $82: 
  begin
    tmp2:=r_A+r_D;
    RF2;
    
    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $83: 
  begin
    tmp2:=r_A+r_E;
    RF2;
    
    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $84: 
  begin
    tmp2:=r_A+r_H;
    RF2;
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $85: 
  begin
    tmp2:=r_A+r_L;
    RF2;
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $86: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=r_A+tmp1;
    RF2;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $87: 
  begin
    tmp2:=r_A+r_A;
    RF2;
    
    if (((tmp2  xor r_A  xor r_A) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $88: 
  begin
    tmp2:=r_A+r_B;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    RF2;
    
    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $89: 
  begin
    tmp2:=r_A+r_C;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    RF2;
    
    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $8A: 
  begin
    tmp2:=r_A+r_D;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    RF2;
    
    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $8B: 
  begin
    tmp2:=r_A+r_E;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    RF2;
    
    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $8C: 
  begin
    tmp2:=r_A+r_H;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    RF2;
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=r_F or f_C;
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $8D: 
  begin
    tmp2:=r_A+r_L;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    RF2;
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $8E: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=r_A+tmp1;
    if ((r_F and f_C)<>0) then  tmp2:=tmp2+1 else tmp2:=tmp2+0;
    RF2;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $8F: 
  begin
    tmp2:=r_A+r_A;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    RF2;

    if (((tmp2  xor r_A  xor r_A) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;

    if (tmp2>$FF) then
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $90: 
  begin
    tmp2:=(r_A-r_B) and $FF;
    RF3;

    if (r_A<r_B) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $91: 
  begin
    tmp2:=(r_A-r_C) and $FF;
    RF3;

    
    if (r_A<r_C) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $92: 
  begin
    tmp2:=(r_A-r_D) and $FF;
    RF3;

    if (r_A<r_D) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $93: 
  begin
    tmp2:=(r_A-r_E) and $FF;
    RF3;
    
    if (r_A<r_E) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $94: 
  begin
    tmp2:=(r_A-r_H) and $FF;
    RF3;
    
    if (r_A<r_H) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $95: 
  begin
    tmp2:=(r_A-r_L) and $FF;
    RF3;
    
    if (r_A<r_L) then 
    begin
      r_F:=r_F or f_C;
    end;
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $96: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=(r_A-tmp1) and $FF;
    RF3;
    
    if (r_A<tmp1) then 
    begin
      r_F:=(r_F or f_C);
    end;

    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+7;
    r_PC:=r_PC+1;

  end;

  $97:
  begin
    rF4;
    r_A:=0;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $98: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_B-tmp3) and $FF;
    RF3;
    
    if (r_A<r_B+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $99: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_C-tmp3) and $FF;
    RF3;
    
    if (r_A<(r_C+tmp3)) then
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $9A: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_D-tmp3) and $FF;
    RF3;
    
    if (r_A<r_D+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $9B: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_E-tmp3) and $FF;
    RF3;
    
    if (r_A<r_E+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $9C: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_H-tmp3) and $FF;
    RF3;

    if (r_A<r_H+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $9D: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_L-tmp3) and $FF;
    RF3;

    if (r_A<r_L+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $9E: 
  begin
    tmp1:=do_read2(r_L,r_H);
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-tmp1-tmp3) and $FF;
    RF3;
    
    if (r_A<tmp1+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $9F: 
  begin
    if ((r_F and f_C)<>0) then tmp2:=$FF else tmp2:=0;
    RF3;
    
    if (tmp2<>0) then 
    begin
      r_F:=r_F or (f_A or f_C);
    end;
    r_A:=tmp2;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $A0: 
  begin
    r_A:=r_A and r_B;
rF5;

    clp4;
    r_PC:=r_PC+1;
    
  end;

  $A1: 
  begin
    r_A:=r_A and r_C;
    rF5;

    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $A2: 
  begin
    r_A:=r_A and r_D;
rF5;

    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $A3: 
  begin
    r_A:=r_A and r_E;
rF5;

    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $A4: 
  begin
    r_A:=r_A and r_H;
rf5;

    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $A5: 
  begin
    r_A:=r_A and r_L;
    RF5;

    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $A6: 
  begin
    tmp1:=do_read2(r_L,r_H);
    r_A:=r_A and tmp1;
    RF5;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $A7: 
  begin
    r_A:=r_A and r_A;
    RF5;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $A8: 
  begin
    r_A:=r_A xor r_B;
    RF5;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $A9: 
  begin
    r_A:=r_A  xor r_C;
    RF5;
    clp4;
    r_PC:=r_PC+1;

  end;

  $AA:
  begin
    r_A:=r_A xor r_D;
    RF5;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $AB: 
  begin
    r_A:=r_A  xor r_E;
    RF5;
    clp4;
    r_PC:=r_PC+1;

  end;

  $AC:
  begin
    r_A:=r_A  xor r_H;
    RF5;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $AD: 
  begin
    r_A:=r_A  xor r_L;
    RF5;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $AE: 
  begin
    tmp1:=do_read2(r_L,r_H);
    r_A:=r_A xor tmp1;
    RF5;
    clock:=clock+7;
    r_PC:=r_PC+1;

  end;

  $AF:
  begin
    r_A:=0;
    RF5;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $B0: 
  begin
    r_A:=r_A or r_B;
    RF5;
    clp4;
    r_PC:=r_PC+1;

  end;

  $B1:
  begin
    r_A:=r_A or r_C;
    RF5;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $B2: 
  begin
    r_A:=r_A or r_D;
    RF5;
    clp4;
    r_PC:=r_PC+1;

  end;

  $B3:
  begin
    r_A:=r_A or r_E;
    RF5;
    clp4;
    r_PC:=r_PC+1;

  end;

  $B4:
  begin
    r_A:=r_A or r_H;
    RF5;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $B5: 
  begin
    r_A:=r_A or r_L;
    RF5;
    clp4;
    r_PC:=r_PC+1;

  end;

  $B6:
  begin
    tmp1:=do_read2(r_L,r_H);
    r_A:=r_A or tmp1;
    RF5;
    clock:=clock+7;
    r_PC:=r_PC+1;

  end;

  $B7:
  begin
    r_A:=r_A or r_A;
    RF5;
    clp4;
    r_PC:=r_PC+1;

  end;

  $B8:
  begin
    tmp2:=(r_A-r_B) and $FF;
    RF3;

    if (r_A<r_B) then
    begin
      r_F:=(r_F or f_C);
    end;

    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    clp4;
    r_PC:=r_PC+1;

  end;

  $B9:
  begin
    tmp2:=(r_A-r_C) and $FF;
    RF3;

    if (r_A<r_C) then
    begin
      r_F:=(r_F or f_C);
    end;

    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    clp4;
    r_PC:=r_PC+1;

  end;

  $BA:
  begin
    tmp2:=(r_A-r_D) and $FF;
    RF3;

    if (r_A<r_D) then
    begin
      r_F:=(r_F or f_C);
    end;

    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    clp4;
    r_PC:=r_PC+1;

  end;

  $BB:
  begin
    tmp2:=(r_A-r_E) and $FF;
    RF3;

    if (r_A<r_E) then
    begin
      r_F:=(r_F or f_C);
    end;

    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $BC: 
  begin
    tmp2:=(r_A-r_H) and $FF;
    RF3;
    
    if (r_A<r_H) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $BD: 
  begin
    tmp2:=(r_A-r_L) and $FF;
    RF3;
    
    if (r_A<r_L) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $BE: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=(r_A-tmp1) and $FF;
    RF3;
    
    if (r_A<tmp1) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $BF:
  begin
    rf4;

    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $C0: 
  begin
    
    if ((r_F and f_Z)<>0) then
     begin
      clock:=clock+5;
      r_PC:=r_PC+1;
     end
        else
     begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
     end;
  end;

  $C1:
  begin
    r_C:=do_read(r_SP);
    r_B:=do_read(r_SP+1);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+10;
    r_PC:=r_PC+1;

  end;

  $C2:
  begin

    if ((r_F and f_Z)<>0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
    else
    begin
      r_PC:=do_read(r_PC+1)+((do_read(r_PC+2) shl 8));
      clock:=clock+10;
    end;
  end;

  $C3:
  begin
    r_PC:=do_read(r_PC+1)+((do_read(r_PC+2) shl 8));
    clock:=clock+10;
  end;

  $C4:
  begin
    if ((r_F and f_Z)<>0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
        else
        begin
      tmp1:=do_read(r_PC+1)+((do_read(r_PC+2) shl 8));
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;

    end;
  end;

  $C5:
  begin
    r_SP:=(r_SP-2) and $FFFF;
    do_write(r_SP,r_C);
    do_write(r_SP+1,r_B);
    clock:=clock+11;
    r_PC:=r_PC+1;

  end;

  $C6:
  begin
    tmp1:=do_read(r_PC+1);
    tmp2:=r_A+tmp1;
    RF2;

    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then
    begin
      r_F:=r_F or f_A;
    end;

    if (tmp2>$FF) then
    begin
      r_F:=r_F or f_C;
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+7;
    r_PC:=r_PC+2;

  end;

  $C7:
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=0*8;
    clock:=clock+11;

  end;

  $C8:
  begin

    if ((r_F and f_Z)=0) then

    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
        else
    begin

      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;

    end;
  end;
  
  $C9: 
  begin
    r_PC:=do_read(r_SP);
    r_PC:=r_PC+(do_read(r_SP+1) shl 8);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+11;
    
  end;
  
  $CA: 
  begin
    
    if ((r_F and f_Z)=0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
        else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;

    end;

  end;
  
  $CB: 
  begin

           begin
            r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
            clock:=clock+10;
           end;
    
  end;
  
  $CC: 
  begin
    
    if ((r_F and f_Z)=0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end
  end;
  
  $CD: 
  begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_SP:=(r_SP-2) and $FFFF;
    r_PC:=r_PC+3;
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=tmp1;
    clock:=clock+17;
    
  end;
  
  $CE: 
  begin
    tmp1:=do_read(r_PC+1);
    tmp2:=r_A+tmp1;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else  tmp2:=tmp2+0;
    RF2;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=r_F or f_A;
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=r_F or f_C;
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $CF: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=1*8;
    clock:=clock+11;
    
  end;
  
  $D0: 
  begin
    
    if ((r_F and f_C)<>0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
     else
     begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
    end
  end;
  
  $D1: 
  begin
    r_E:=do_read(r_SP);
    r_D:=do_read(r_SP+1);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+10;
    r_PC:=r_PC+1;
    
  end;
  
  $D2: 
  begin
    if ((r_F and f_C)<>0) then

    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
     else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;
    end;
  end;
  
  $D3: 
  begin
    do_output(do_read(r_PC+1),r_A);
    clock:=clock+10;
    r_PC:=r_PC+2;
    
  end;
  
  $D4: 
  begin
    
    if ((r_F and f_C)<>0) then
   
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
     else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $D5: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    do_write(r_SP,r_E);
    do_write(r_SP+1,r_D);
    clock:=clock+11;
    r_PC:=r_PC+1;
    
  end;
  
  $D6: 
  begin
    tmp1:=do_read(r_PC+1);
    tmp2:=(r_A-tmp1) and $FF;
    RF3;
    
    if (r_A<tmp1) then 
    begin
      r_F:=r_F or f_C;
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=r_F or f_A;
    end;
    r_A:=tmp2;
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $D7: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=2*8;
    clock:=clock+11;
    
  end;
  
  $D8: 
  begin
    
    if ((r_F and f_C)=0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
    else
    begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+do_read(r_SP+1) shl 8;
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
    end;
  end;
  
  $D9: 
  begin

           begin
            r_PC:=do_read(r_SP);
            r_PC:=r_PC+do_read(r_SP+1) shl 8;
            r_SP:=(r_SP+2) and $FFFF;
            clock:=clock+11;
           end;
    
  end;
  
  $DA: 
  begin
    
    if ((r_F and f_C)=0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
     else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;
    end;
  end;
  
  $DB: 
  begin
    r_A:=do_input(do_read(r_PC+1));
    clock:=clock+10;
    r_PC:=r_PC+2;
    
  end;
  
  $DC: 
  begin
    
    if ((r_F and f_C)=0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $DD:    begin

    begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_SP:=(r_SP-2) and $FFFF;
    r_PC:=r_PC+3;
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=tmp1;
    clock:=clock+17;
    end;
  end;


  $ED:    begin

    begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_SP:=(r_SP-2) and $FFFF;
    r_PC:=r_PC+3;
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=tmp1;
    clock:=clock+17;
    end;
  end;


  $FD:
  begin

    begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_SP:=(r_SP-2) and $FFFF;
    r_PC:=r_PC+3;
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=tmp1;
    clock:=clock+17;
    end;
  end;

  $DE: 
  begin
    tmp1:=do_read(r_PC+1);
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-tmp1-tmp3) and $FF;
    RF3;
    
    if (r_A<tmp1+tmp3) then 
    begin
      r_F:=r_F or f_C;
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=r_F or f_A;
    end;
    r_A:=tmp2;
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $DF: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=3*8;
    clock:=clock+11;
    
  end;
  
  $E0: 
  begin
    if ((r_F and f_P)<>0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
    else
    begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+do_read(r_SP+1) shl 8;
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
    end ;
    
  end;
  
  $E1: 
  begin
    r_L:=do_read(r_SP);
    r_H:=do_read(r_SP+1);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+10;
    r_PC:=r_PC+1;
    
  end;
  
  $E2: 
  begin
    
    if ((r_F and f_P)<>0) then
    
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
    else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;

    end;
    
  end;
  
  $E3: 
  begin
    tmp1:=do_read(r_SP);
    do_write(r_SP,r_L);
    r_L:=tmp1;
    tmp1:=do_read(r_SP+1);
    do_write(r_SP+1,r_H);
    r_H:=tmp1;
    clock:=clock+18;
    r_PC:=r_PC+1;
    
  end;
  
  $E4: 
  begin
    
    if ((r_F and f_P)<>0) then
    
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;

    end;
    
  end;
  
  $E5: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    do_write(r_SP,r_L);
    do_write(r_SP+1,r_H);
    clock:=clock+11;
    r_PC:=r_PC+1;
    
  end;
  
  $E6: 
  begin
    r_A:=r_A and do_read(r_PC+1);
    RF5;
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $E7: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=4*8;
    clock:=clock+11;
    
  end;
  
  $E8: 
  begin
    if ((r_F and f_P)=0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
     else
    begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+do_read(r_SP+1) shl 8;
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;

    end;
    
  end;
  
  $E9: 
  begin
    r_PC:=(r_H shl 8)+r_L;
    clock:=clock+5;
  end;
  
  $EA: 
  begin
    
    if ((r_F and f_P)=0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;  
    end
    else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;

    end;
  end;
  
  $EB: 
  begin
    tmp1:=r_D;
    r_D:=r_H;
    r_H:=tmp1;
    tmp1:=r_E;
    r_E:=r_L;
    r_L:=tmp1;
    clp4;
    r_PC:=r_PC+1;
    
  end;
  
  $EC: 
  begin
    if ((r_F and f_P)=0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $EE: 
  begin
    r_A:= r_A xor do_read(r_PC+1);
    RF5;
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $EF: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=5*8;
    clock:=clock+11;
  end;
  
  $F0: 
  begin
    if ((r_F and f_S)<>0) then
     begin
      clock:=clock+5;
      r_PC:=r_PC+1;
     end
     else
     begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
    end;
  end;
  
  $F1: 
  begin
    r_F:=do_read(r_SP);
    r_A:=do_read(r_SP+1);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $F2: 
  begin
    if ((r_F and f_S)<>0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
    else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;
    end;
  end;
  
  $F4: 
  begin
    
    if ((r_F and f_S)<>0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $F5: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    do_write(r_SP,r_F);
    do_write(r_SP+1,r_A);
    clock:=clock+11;
    r_PC:=r_PC+1;
    
  end;
  
  $F6: 
  begin
    r_A:=r_A or do_read(r_PC+1);
    RF5;
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $F7: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=6*8;
    clock:=clock+11;
    
  end;
  
  $F8: 
  begin
    if ((r_F and f_S)=0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
     else
    begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;

    end;
  end;
  
  $F9: 
  begin
    r_SP:=(r_H shl 8)+r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $FA: 
  begin
    if ((r_F and f_S)=0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
     else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;
    end;
  end;
  
  $FC: 
  begin
    if ((r_F and f_S)=0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $FE: 
  begin
    tmp1:=do_read(r_PC+1);
    tmp2:=(r_A-tmp1) and $FF;
    RF3;

    if (r_A<tmp1) then
    begin
      r_F:=r_F or f_C;
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=r_F or f_A;
    end;
    clock:=clock+7;
    r_PC:=r_PC+2;

  end;
  
  $FF: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=7*8;
    clock:=clock+11;

  end
  else
  begin
     // cpu_halt_state:=true;
     // cpu_halt_reason:=halt_inv;
  end;

end;
end;
rgA:=Cardinal(r_A);rgB:=Cardinal(r_b);rgC:=Cardinal(r_c);rgD:=Cardinal(r_d);
rgE:=Cardinal(r_e);rgH:=Cardinal(r_H);rgL:=Cardinal(r_L);rgF:=Cardinal(r_F);
rgPC:=Cardinal(r_PC);rgSP:=Cardinal(r_SP);

fS:=Cardinal(f_S);fZ:=Cardinal(f_Z);f5:=Cardinal(f_5);fA:=Cardinal(f_A);
f3:=Cardinal(f_3);fP:=Cardinal(f_P);f1:=Cardinal(f_1);fC:=Cardinal(f_C);
end;


procedure TMainForm.draw_screen;   //  video    ()

var
  i,vertX,gorY : word;
begin
  i:=0;
  vertX:=0;
  gorY:=0;
  while (i<$4000) do
  begin
   if video[i]<>VideoDirty[i] then //  ,    
        begin
          //WriteVRAM(video[i],vertX,gorY);   //     
        //if not N7.Checked then  //   
          begin
          gamecanvas.Canvas.Pixels[vertX,gorY]:=  SuperColor[ports[$C1],video[i],1];
          gamecanvas.Canvas.Pixels[vertX+1,gorY]:=SuperColor[ports[$C1],video[i],2];
          gamecanvas.Canvas.Pixels[vertX+2,gorY]:=SuperColor[ports[$C1],video[i],3];
          gamecanvas.Canvas.Pixels[vertX+3,gorY]:=SuperColor[ports[$C1],video[i],4];
          end;


        end;
    vertX:=vertX+4;
    if vertX>=256 then begin vertX:=0; gorY:=gorY+1; end;
    inc(i);
  end;
{$R-}
for I := 0 to $4000 do VideoDirty[i]:= video[i];  //   
{$R+}
//if FullScreen1.Checked then                        //     
MainForm.Canvas.StretchDraw(rect(0,0,MainForm.Width-0,MainForm.Height-30), gamecanvas)
//else
//MainForm.Canvas.Draw(0,0,gamecanvas);
end;


procedure TMainForm.VRAMTest(c1,b:Byte);

Var

pix1,pix2,pix3,pix4:byte;
begin
   pix1:=0; pix2:=0; pix3:=0; pix4:=0;
  if (b and 128)=128 then pix1:=pix1+1;
  if (b and 8)=8     then pix1:=pix1+2;
  if (b and 64)=64   then pix2:=pix2+1;
  if (b and 4)=4     then pix2:=pix2+2;
  if (b and 32)=32   then pix3:=pix3+1;
  if (b and 2)=2     then pix3:=pix3+2;
  if (b and 16)=16   then pix4:=pix4+1;
  if (b and 1)=1     then pix4:=pix4+2;

  SuperColor[c1,b,1]:=compute_color_index(c1,Mycolor[pix1]);

  SuperColor[c1,b,2]:=compute_color_index(c1,Mycolor[pix2]);

  SuperColor[c1,b,3]:=compute_color_index(c1,Mycolor[pix3]);

  SuperColor[c1,b,4]:=compute_color_index(c1,Mycolor[pix4]);

end;

procedure TMainForm.CalculateColor;
var
  I,j: Integer;
begin
for I := 0 to 255 do
   for j := 0 to 255 do
    begin
       VRAMTest(i, j);
    end;
end;


function TMainForm.compute_color_index(port : byte; color : tcolor): tcolor;  //      

begin
  Result:=ClBLACK;
  if ((port and $40)<>0) then Result:= (Result xor ClBLUE);
  if ((port and $20)<>0) then Result:= (Result xor clLime);
  if ((port and $10)<>0) then Result:= (Result xor ClRED);
  case color of
  clBLACK:
     begin
       if ((port and $08)=0) then
         begin
           Result:= (Result xor CLRED);
         end;
       if ((port and $04)=0) then
         begin
          Result:= (Result xor ClBLUE);
         end;
      end;
   clLime: begin
      Result:= (Result xor clLime);
      end;
   clred:  begin
       Result:= (Result xor ClRED);
       if ((port and $02)=0) then
           begin
             //Result:= (Result xor ClGREEN);
             Result:= (Result xor clLime);
           end;
        end;
    clBLUE: begin
         Result:= (Result xor ClBLUE);
         if ((port and $01)=0) then
            begin
             Result:= (Result xor ClRED);
            end;
       end;
end;
   // result:= ((Result and $07) shl 13) or ((Result and $38) shl 5) or ((Result and $C0) shr 3);
end;



procedure TMainForm.WriteVRAM(b:Byte;x,y: integer);  //   gamecanvas   ,     1

Var
pix1,pix2,pix3,pix4:byte;
begin
  pix1:=0; pix2:=0; pix3:=0; pix4:=0;        //      
  if (b and 128)=128 then pix1:=pix1+1;
  if (b and 8)=8     then pix1:=pix1+2;
  if (b and 64)=64   then pix2:=pix2+1;
  if (b and 4)=4     then pix2:=pix2+2;
  if (b and 32)=32   then pix3:=pix3+1;
  if (b and 2)=2     then pix3:=pix3+2;
  if (b and 16)=16   then pix4:=pix4+1;
  if (b and 1)=1     then pix4:=pix4+2;



    begin
     gamecanvas.Canvas.Pixels[x,y]:=  compute_color_index(ports[$C1],Mycolor[pix1]);
     gamecanvas.Canvas.Pixels[x+1,y]:=compute_color_index(ports[$C1],Mycolor[pix2]);
     gamecanvas.Canvas.Pixels[x+2,y]:=compute_color_index(ports[$C1],Mycolor[pix3]);
     gamecanvas.Canvas.Pixels[x+3,y]:=compute_color_index(ports[$C1],Mycolor[pix4]);
     end;
end;



procedure TMainForm.FirstPusk; // 
 begin
 //    
 gamecanvas:=tbitmap.Create;
 gamecanvas.Width:=256;
 gamecanvas.Height:=256;

  ResetComp; //   
  TimerMain.Enabled:=true; //   
end;

function TMainForm.readmask (keynum: word): word;    //  
begin
result:= $72FF;
case keynum of
      8: begin result:= $23FF end;  // BCK
     13: begin result:= $13FF end;  // ENTER
	   16: begin result:= $70FF end;  // SHIFT
     32: begin result:= $30FF end;  // SPC

     37: begin result:= $FF32 end;  //  <-
     38: begin result:= $FF31 end;  //  UP
     39: begin result:= $FF30 end;  //  ->
     40: begin result:= $FF33 end;  //  DOWN

     48: begin result:= $06FF end;  //   0
	   49: begin result:= $47FF end;  //   1
	   50: begin result:= $46FF end;  //   2
   	 51: begin result:= $45FF end;  //   3
  	 52: begin result:= $44FF end;  //   4
   	 53: begin result:= $43FF end;  //   5
   	 54: begin result:= $00FF end;  //   6
  	 55: begin result:= $01FF end;  //   7
  	 56: begin result:= $02FF end;  //   8
  	 57: begin result:= $07FF end;  //   9

  	 65: begin result:= $64FF end;  //   A
     66: begin result:= $31FF end;  //   B
     67: begin result:= $57FF end;  //   C
     68: begin result:= $27FF end;  //   D
     69: begin result:= $54FF end;  //   E
     70: begin result:= $67FF end;  //   F
     71: begin result:= $10FF end;  //   G
  	 72: begin result:= $16FF end;  //   H
  	 73: begin result:= $75FF end;  //   I
  	 74: begin result:= $52FF end;  //   J
     75: begin result:= $55FF end;  //   K
   	 76: begin result:= $22FF end;  //   L
  	 77: begin result:= $76FF end;  //   M
  	 78: begin result:= $53FF end;  //   N
   	 79: begin result:= $21FF end;  //   O
   	 80: begin result:= $63FF end;  //   P
  	 81: begin result:= $71FF end;  //   Q
     82: begin result:= $20FF end;  //   R
   	 83: begin result:= $77FF end;  //   S
   	 84: begin result:= $74FF end;  //   T
     85: begin result:= $56FF end;  //   U
  	 86: begin result:= $26FF end;  //   V
  	 87: begin result:= $65FF end;  //   W
   	 88: begin result:= $73FF end;  //   X
   	 89: begin result:= $66FF end;  //   Y
  	 90: begin result:= $17FF end;  //   Z

  	 107: begin result:= $05FF end;  //   =/+ -> =/-
  	 109: begin result:= $05FF end;  //   -/_ -> =/-

  	 114: begin result:= $FF23 end;  // F3
  	 115: begin result:= $FF22 end;  // F4
   	 116: begin result:= $FF21 end;  // F5

  	 36: begin result:= $FF20 end;  // Home

  	 219: begin result:= $11FF end;  //   [
  	 221: begin result:= $12FF end;  //   ]
  	 190: begin result:= $24FF end;  //   .
   	 188: begin result:= $37FF end;  //   ,
   	 192: begin result:= $72FF end;  //
end;

end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
if FPusk then    //     
    begin
    FPusk:=false;
    FirstPusk;
    end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
DragAcceptFiles(MainForm.Handle, true);   //     :)
CalculateColor;
FPusk:=true; //   
English1Click(Sender);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
DragAcceptFiles(Handle, False);

end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;  // 
  Shift: TShiftState);
begin
    kbd(readmask(key),true);  // 
    i8080_do_opcodes(opcodes_to_run);
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   kbd(readmask(key),false); // 
end;

procedure TMainForm.TimerMainTimer(Sender: TObject);  //  
var
j,a: word;
i: integer;
s: string;
begin
if (pause) then  //     :)
  begin
    exit;
  end;
 i8080_do_opcodes(opcodes_to_run);
 draw_screen;

end;

procedure TMainForm.ResetComp;
begin
 rgB := 0; rgC := 0; rgD := 0; rgE := 0; rgH := 0; rgL := 0; rgA := 0; rgF := 0;
 rgPC := 0; rgSP := 0;
// clock := 0; //  

 halt_inv := 1;
 halt_opc := 2;
 halt_hlt := 3;

 halt_bpx := 4;
 halt_bpr := 5;
 halt_bpw := 6;
 halt_bpi := 7;
 halt_bpo := 8;



 pause := false;
 FPS := 50;


 speaked := 0;

 fS := (1 SHL 7);
 fZ :=( 1 SHL 6);
 f5 := (1 SHL 5);
 fA := (1 SHL 4);
 f3 := (1 SHL 3);
 fP := (1 SHL 2);
 f1 := (1 SHL 1);
 fC := (1 SHL 0);

 BasicStack := $AFC1;
 BasicHotEntry := $02FD;
 BasicProgBegin := $0243;
 BasicProgEnd := $0245;


  fillchar(VideoDirty,sizeof(VideoDirty),257);

  soundEnabled := false;
 // opcodes_to_run := round ((1411200*4)/FPS);
  opcodes_to_run := round ((1411200*2)/FPS);
  curSnd := 0;
  restClock := 0;
  init_memory();
  reset1();
  load_bios();
  i8080_do_opcodes(0);
end;

procedure TMainForm.ResetCPU1Click(Sender: TObject);
begin
ResetComp;
end;





procedure TMainForm.English1Click(Sender: TObject);
begin


MainForm.Caption:='PK-01 Lvov emulator';

//DebuggerForm.TabSheet1.Caption:='Assembler';
//DebuggerForm.TabSheet2.Caption:='Find-replace in memory';


N1.Caption:='File';
N2.Caption:='Open';
ResetCPU1.Caption:='Reset CPU';
N11.Caption:='Pause';
N4.Caption:='Exit';





end;

procedure TMainForm.Russian1Click(Sender: TObject);
begin


MainForm.Caption:='-01  ';

//DebuggerForm.TabSheet1.Caption:='';
//DebuggerForm.TabSheet2.Caption:='-  ';

N1.Caption:='';
N2.Caption:='';
ResetCPU1.Caption:='Reset CPU';
N11.Caption:='';
N4.Caption:='';

end;


// ###################################################  :-) ##############################################################










end.
